//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainU.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner), FReg(new TRegistry( ) )
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::miDeleteClick(TObject *Sender)
{
  FReg->RootKey = HKEY_LOCAL_MACHINE;
  if ( ( lvBHO->SelCount > 0 )
    && ( FReg->OpenKey( "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Browser Helper Objects", false ) )
    && ( Application->MessageBox( "Are you sure?", "please confirm", MB_ICONQUESTION | MB_YESNO ) == IDYES )
    )
  {
    AnsiString s;
    TListItem * pItem;
    for ( int i = lvBHO->Items->Count - 1; i >= 0; --i )
    {
      pItem = lvBHO->Items->Item[i];
      if ( pItem->Selected )
      {
        s = "regsvr32 -u \"";
        s += pItem->SubItems->Strings[1] + "\"";
        WinExec( s.c_str(), SW_HIDE );
        FReg->DeleteKey( pItem->SubItems->Strings[0] );
        lvBHO->Items->Delete( i );
      }
    }
  }
  FReg->CloseKey( );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
  FReg->RootKey = HKEY_LOCAL_MACHINE;
  if ( FReg->OpenKey( "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Browser Helper Objects", false ) )
  {
    boost::scoped_ptr<TStrings> ss( new TStringList() );
    FReg->GetKeyNames( ss.get() );
    FReg->CloseKey( );
    FReg->RootKey = HKEY_CLASSES_ROOT;
    AnsiString s;
    TListItem * pItem;
    for ( int i = 0; i < ss->Count; ++i )
    {
      s = AnsiString( "CLSID\\" + ss->Strings[i] );
      if ( FReg->OpenKey( s, false ) )
      {
        pItem = lvBHO->Items->Add( );
        pItem->Caption = FReg->ReadString( "" );
        pItem->SubItems->Add( ss->Strings[i] );
        if ( FReg->OpenKey( "InprocServer32", false ) )
          pItem->SubItems->Add( FReg->ReadString( "" ) );
      }
      FReg->CloseKey( );
    }
  }  
}
//---------------------------------------------------------------------------
